var readline = require("readline-sync")

var forza4 = [];
var nColonne = 7;
var nLinee = 6;
var player1 = sceltaCarattere(1); // "x"
var player2 = sceltaCarattere(2); // "o"

benvenuto();
forza4 = initTable(nLinee, nColonne, 0);
mostraForza4(forza4, player1, player2);

while(true)
{
    if(gameCase(1))
    {
        console.log("Il player 1 ha vinto");
        break;
    }
    if(gameCase(2))
    {
        console.log("Il player 2 ha vinto");
        break;
    }
}

function benvenuto()
{
    var txt ="***********************************************\n";    
    txt += "Benvenuto/a su Forza 4\n";
    txt += "******************************************************";
    console.log(txt);
}

function sceltaCarattere(player)
{
    var txt = "Scegli la lettera o simbolo che vuoi utilizzare per il giocatore " + player + ":";
    return scriviStringa(txt);
}

function scriviStringa(txt)
{
    return readline.question(txt);
}

/**
 * Verifica che il giocatore 1 sta in game
 * @param {*} player 
 * @returns 
 */
function gameCase(player)
{
    var lineaVuota = -1;
    var colonna = -1;
    while(lineaVuota === -1 || colonna <= 0 || colonna > 7)
    {
        console.log("Scegliere una colonna in una zona vuota");
        var colonna = scegliereColonna();
        var lineaVuota = ritornaLineaCasellaVuotaColonna(colonna);
    }
    forza4[lineaVuota][colonna-1] = player;
    mostraForza4(forza4, player1, player2);
    return verificaFineDelGioco(player); // aggiungere player
}

function scegliereColonna()
{
    return parseInt(readline.question("Quale colonna scegli?"));
}

/**
 * Funzione che permette di ottenere la prima linea VUOTA di una colonna
 * @param {*} colonna ritorna -1 se la colonna è piena
 * @returns 
 */
function ritornaLineaCasellaVuotaColonna(colonne)
{
    for(var i = nLinee-1; i >= 0; i--)
    {
        if(verificaCasellaVuota(i, colonne)) return i;
    }
    return -1;
}

/**
 * Funzione che permette di otenere se una casella è vuota (ritorna true/false)
 * @param {*} linea 
 * @param {*} colonna 
 * @returns 
 */
function verificaCasellaVuota(linea, colonna)
{
    return forza4[linea][colonna-1] === 0;
}

function verificaFineDelGioco(player)
{
    if(verificaLineaFineGioco(player) ||
        verificaColonnaFineGioco(player) || 
        verificaDiagonaleFineGioco(player)) 
    {
        return true;
    }
    return false;
}

/**
 * Funzione che permette di verificare se un giocatore ha vinto su una linea
 * @param {*} player 
 * @returns 
 */
function verificaLineaFineGioco(player)
{
    for(var i = nLinee-1; i >= 0; i--)
    {
        for(var i=nLinee-1;i>=0; i--)
        {
            for (var j=0;j<nColonne-3;j++)
            {
                if( forza4[i][j] === player &&
                    forza4[i][j+1] === player &&
                    forza4[i][j+2] === player &&
                    forza4[i][j+3] === player
                    )
                {
                    return true;
                }
            }
        }
    }
    return false;
}

/**
 * Funzione che permette di verificare se un giocatore ha vinto su una colonna
 * @param {*} player 
 * @returns 
 */
function verificaColonnaFineGioco(player)
{
    for(var i = 0; i<nColonne;i++)
    {
        for(var j=nLinee-4;j>=0;j--)
        {
            if( forza4[j][i] === player &&
                forza4[j+1][i] === player &&
                forza4[j+2][i] === player &&
                forza4[j+3][i] === player
                ) return true;
        }
    }
}

/**
 * Funzione che permette di verificare se un giocatore ha vinto sulla diagonale
 * @param {*} player 
 * @returns 
 */
function verificaDiagonaleFineGioco(player)
{
    for(var i=nLinee-1;i>=3; i--)
    {
        for (var j=0;j<nColonne;j++)
        {
            if( forza4[i][j] === player &&
                forza4[i-1][j+1] === player &&
                forza4[i-2][j+2] === player &&
                forza4[i-3][j+3] === player
                ) return true;
            if( forza4[i][j] === player &&
                forza4[i-1][j-1] === player &&
                forza4[i-2][j-2] === player &&
                forza4[i-3][j-3] === player
                ) return true;
        }
    }
    return false;
}

/**
 * Permette di initializzare una tabella in una tabella in funzione di un numero di linee e di colonne messe come parametri
 * @param {*} nLinee 
 * @param {*} nColonne 
 * @param {*} element 
 * @returns 
 */
function initTable(nLinee, nColonne, element = '')
{
    var tab = [];
    for(var i = 0; i < nLinee; i++) 
    {
        var linea = [];
        for(var j = 0; j < nColonne; j++)
        {
            linea.push(element);
        }
        tab.push(linea);
    }
    return tab;
}

/**
 * Permette di mostrare una tabella in stile forza 4
 * @param {*} tab 
 * @param {*} p1el 
 * @param {*} p2el 
 */
function mostraForza4(tab, p1el, p2el)
{
    for(var i = 0; i < tab.length; i++)
    {
        var linea = "";
        for(var j = 0; j < tab[i].length; j++)
        {
            linea += "| ";
            if(tab[i][j] === 0) 
            {
                linea += "_";
            }
            else if(tab[i][j] === 1) 
            {
                linea += p1el;
            }
            else if(tab[i][j] === 2) 
            {
                linea += p2el;
            }
            linea += "| ";
        }
        console.log(linea);
    }
}